; Holzchopfs Beitrag zum BCC#16
Graphics3D 800, 600, 0, 2
SetBuffer BackBuffer()
SeedRnd MilliSecs()
Global TIMER = CreateTimer( 60 )
Local a,Dir,File,cnt,f,txt$

Global gCam=CreateCamera()
CameraClsMode gCam,0,1
CameraProjMode gCam,2
CameraZoom gCam,.0025
RotateEntity gCam,180,0,0
PositionEntity gCam,400,300,10
Global gParent=CreatePivot()

Global gImgBG=LoadImage("gfx/bg.jpg")

Global gFx1a=LoadBrush("gfx/sel1.png",50)
BrushColor gFx1a,255,0,0
Global gFx1b=LoadBrush("gfx/sel1.png",50)
BrushColor gFx1b,196,48,48
BrushAlpha gFx1b,.8
Global gFx2=LoadBrush("gfx/sel2.png",50)
BrushColor gFx2,255,0,0

Global gImgFig[7]
For a=1 To 8
	gImgFig[a-1]=LoadBrush("gfx/Fig"+a+".png",50)
Next

Global gFnt1=LoadFont("Tahoma",26,1)
Global gFnt2=LoadFont("Tahoma",14)

Global gf1=LoadBrush("gfx/gf1.png",50)
Global gf2=LoadBrush("gfx/gf2.png",50)
Global gf3=LoadBrush("gfx/gf3.png",50)
Global gf4=LoadBrush("gfx/gf4.png",50):BrushColor gf4,255,0,0

Global mx,my,mhit,MSec
Global khFig[4],khSpl[9],kName$[9]
kName[0]="Q"
kName[1]="W"
kName[2]="E"
kName[3]="R"
kName[4]="T"
kName[5]="Z"
kName[6]="U"
kName[7]="I"
kName[8]="O"
kName[9]="P"

Type tAni
	Field cnt,fr[9],t[9],x[9],y[9]
End Type
Global gAni.tAni
Dim Ani.tAni(7)
File=ReadFile("ani.dat")
For a=0 To 7
	gAni=New tAni
	gAni\cnt=ReadInt(File)
	For f=0 To gAni\cnt-1
		gAni\fr[f]=ReadInt(File)
		gAni\t[f]=ReadInt(File)
		gAni\x[f]=ReadInt(File)
		gAni\y[f]=ReadInt(File)
	Next
	Ani(a)=gAni
Next

Type tIcon
	Field Name$,Img
End Type
Local Icon.tIcon
Dir=ReadDir("gfx/icons")
Repeat
	txt=NextFile(Dir)
	Icon=New tIcon
	Icon\Name=txt
	Icon\Img=LoadBrush("gfx/icons/"+txt,50)
Until txt=""

Type tSpell
	Field Name$,Desc$,Icon,Ani
	Field AType,Loop
	Field pDmg,mDmg,Time,CD
End Type
Global gSpell.tSpell
Local nSpell.tSpell
Dim Spells.tSpell(99)
File=ReadFile("spells.dat")
For a=1 To 14
	gSpell=New tSpell
	gSpell\Name=ReadString(File)
	gSpell\Desc=ReadString(File)
	txt=ReadString(File)
	For Icon=Each tIcon
		If Icon\Name=txt Exit
	Next
	gSpell\Icon=Icon\Img
	gSpell\AType=ReadInt(File)
	gSpell\pDmg=ReadInt(File)
	gSpell\mDmg=ReadInt(File)
	gSpell\Time=ReadInt(File)
	gSpell\CD=ReadInt(File)
	gSpell\Loop=ReadInt(File)
	gSpell\Ani=ReadInt(File)
	Spells(a)=gSpell
Next

Global gFigFile=ReadFile("figures.dat")
Type tPlayer
	Field Ani,A0,Afr,At
	Field hp,pDef,mDef
	Field Spl.tSpell[9],CD[9],SplI,nSplI
	Field Act.tSpell,nAct.tSpell,Trg,exec
	Field sAct.tSpell,sTrgt
	Field Time
End Type
Global Plr.tPlayer[9]
For a=0 To 9
	Plr[a]=New tPlayer
Next

Type tTxt
	Field txt$,x,y,c,time
End Type
Global gTxt.tTxt

Type tSkl
	Field txt$,time
End Type
Dim gSkl.tSkl(16)
Global Skl, Plrs
File=ReadFile("skills.dat")
For a=0 To 16
	gSkl(a)=New tSkl
	gSkl(a)\txt$=ReadString(File)
	gSkl(a)\time=ReadInt(File)
Next

.Menu
SetFont gFnt1
While Not KeyHit(1)
	Cls2
	mx=MouseX()
	my=MouseY()
	mhit=MouseHit(1)

	If Btn(150) Plrs=(Plrs+1)Mod 5
	If Btn(250) Skl=(Skl+1)Mod 6
	If Btn(350) Goto Game
	If Btn(450) End

	RenderWorld

	Color 255,255,0
	Text 400,140,"Spieler:",1,1
	Text 400,160,(Plrs+1)+" vs "+(Plrs+1),1,1
	Text 400,260,gSkl(Skl)\txt,1,1
	Text 400,240,"Modus:",1,1
	Text 400,260,gSkl(Skl)\txt,1,1
	Text 400,350,"Starten",1,1
	Text 400,450,"Beenden",1,1

	Flip 0
	WaitTimer( TIMER )
Wend
End

.Game
FlushKeys()
Local Sel=-1,Aim=0,SplI,Sym,CD,Trg,fr,x,y,xt,yt,xo,yo,w,AiT=MilliSecs()+gSkl(Skl)\time,t,Lf1,Lf2,hp,pts=0
For a=0 To 9
	loadFigure Plr[a],Rand(0,1)
	If (a Mod 5)>Plrs Plr[a]\hp=0
Next
While Not KeyHit(1)
	Cls2
	mx=MouseX()
	my=MouseY()
	mhit=MouseHit(1)
	MSec=MilliSecs()
	For a=0 To 4
		khFig[a]=KeyHit(a+2)
	Next
	For a=0 To 9
		khSpl[a]=KeyHit(a+16)
	Next

	If Sel=>0
		For a=0 To 9
			gSpell=Plr[Sel]\Spl[a]
			If gSpell<>Null
				CD=Plr[Sel]\CD[a]
				x=164+a*48:y=536:w=40
				If gSpell=Plr[Sel]\Act Or MSec<CD:x=x+4:y=y+4:w=32:EndIf
				Draw gSpell\Icon,x,y,w,w,0
				If MSec<CD
					BrushAlpha gf3,.99*(CD-MSec)/gSpell\CD
					Draw gf3,164+a*48,552,24,24,1
				Else
					Color 255,255,0
					SetFont gFnt2
					Text 164+a*48,576,kName[a]
					If mx=>164+a*48 And mx<204+a*48 And my=>536 And my<576 Or khSpl[a]
						Color 255,255,0
						SetFont gFnt1
						Text 400,496,gSpell\Name,1,1
						SetFont gFnt2
						Text 400,516,gSpell\Desc,1,1
						If mhit Or khSpl[a]
							nSpell=gSpell
							Sym=nSpell\Icon
							SplI=a
							If (gSpell\AType And 26)>0
								Aim=0
								Plr[Sel]\nAct=gSpell
								Plr[Sel]\nSplI=SplI
								Plr[Sel]\Trg=-1
							ElseIf gSpell\AType=1
								Aim=1
							Else
								Aim=2
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		If Plr[Sel]\hp<1:Sel=-1:Sym=0:Aim=0:EndIf
	EndIf

	Lf1=0:Lf2=0
	For a=0 To 9
	hp=Plr[a]\hp
	If hp>0
		If a<5:Lf1=Lf1+hp:Else:Lf2=Lf2+hp:EndIf

		If MSec=>Plr[a]\Time And Plr[a]\Act<>Null
			If Plr[a]\nAct=Null And Plr[a]\Act\Loop
				Plr[a]\nAct=Plr[a]\Act
			EndIf
			Plr[a]\Act=Null
		EndIf
		If Plr[a]\Act=Null
			Trg=Plr[a]\Trg
			If Trg=>0:If Plr[Trg]\hp<1
				Plr[a]\nAct=Null
				Plr[a]\Trg=-1
			EndIf:EndIf
			Plr[a]\Act=Plr[a]\nAct
			Plr[a]\SplI=Plr[a]\nSplI
			Plr[a]\nAct=Null
			If Plr[a]\Act<>Null
				Plr[a]\Ani=Plr[a]\Act\Ani
				Plr[a]\Afr=0
				Plr[a]\At=MSec+Ani(Plr[a]\Act\Ani)\t[0]
				Plr[a]\Time=MSec+Plr[a]\Act\Time
				Plr[a]\exec=1
				Plr[a]\CD[Plr[a]\SplI]=MSec+Plr[a]\Act\CD
			EndIf
		EndIf
	
		gAni=Ani(Plr[a]\Ani)
		If MSec=>Plr[a]\At
			Plr[a]\Afr=Plr[a]\Afr+1
			If Plr[a]\Afr=gAni\cnt
				Plr[a]\Ani=Plr[a]\A0
				Plr[a]\Afr=0
				Plr[a]\At=MSec+gAni\t[0]
			Else
				Plr[a]\At=MSec +gAni\t[Plr[a]\Afr]
			EndIf
		EndIf
		fr=gAni\fr[Plr[a]\Afr]
		xo=gAni\x[Plr[a]\Afr]
		yo=gAni\y[Plr[a]\Afr]

		If a<5:x=a*48:y=400-a*40:w=128:Else:x=912-a*48:y=600-a*40:w=-128:EndIf
		Draw gImgFig[fr],x+xo,y+yo,w,128,5-a
		Draw gf1,x+40,y+128,.096*Plr[a]\hp,8,5-a
		Draw gf2,x+40,y+128,48,8,5-a-.1
		SetFont gFnt2
		Color 255,255,0
		If (Aim=0 Or Aim=2) And a<5 Text x+64,y+134,(a+1),1
		If Aim=1 And a>4 Text x+64,y+134,(a-4),1
		If mx=>x+40 And mx<x+88 And my=>y And my<y+128 Or khFig[a Mod 5]
			t=Plr[a]\Trg
			If t=>0
				If t<5:xt=48+t*48:yt=400-t*40:Else:xt=960-t*48:yt=600-t*40:EndIf
				Draw gf4,xt,yt,32,32,10
			EndIf
			If Aim=0 And a<5
				Draw gFx1b,x+16,y+100,92,48,5-a-.9
				If mhit Or khFig[a Mod 5] Sel=a
			ElseIf Aim=2 And a<5
				Draw gFx2,x+16,y+100,92,48,5-a-.9
				If (mhit Or khFig[a Mod 5]) And Sel=>0
					Plr[Sel]\nAct=nSpell
					Plr[Sel]\nSplI=SplI
					Plr[Sel]\Trg=a
					Aim = 0
				EndIf
			ElseIf Aim=1 And a>4
				Draw gFx2,x+16,y+100,92,48,5-a-.9
				If (mhit Or khFig[a Mod 5]) And Sel=>0
					Plr[Sel]\nAct=nSpell
					Plr[Sel]\nSplI=SplI
					Plr[Sel]\Trg=a
					Aim=0
				EndIf
			EndIf
		EndIf
		If Sel=a Draw gFx1a,16+a*48,500-a*40,92,48,5-a-.8
	EndIf
	Next

	If MSec>AiT:AI:AiT=MSec+gSkl(Skl)\time-Rand(0,200):EndIf
	Battle

	ShowCooldowns()
	
	

	If Aim>0 Draw Sym,mx-18,my+6,16,16,10
	If Lf1=0 Or Lf2=0
		If Btn(220) Exit
	EndIf

	RenderWorld

	SetFont gFnt1
	Color 255,0,0
	If Lf2=0
		If Not pts pts=Lf1
		Text 400,60,"Gratulation, du hast "+pts+" Punkte!",1,1
	ElseIf Lf1=0
		Text 400,60,"Du hast verloren und 0 Punkte",1,1
	EndIf
	If Lf1=0 Or Lf2=0:Color 255,255,0:Text 400,220,"OK",1,1:EndIf
	For gTxt=Each tTxt
		gTxt\y=gTxt\y-1
		Color 0,0,gTxt\c
		Text gTxt\x,gTxt\y,gTxt\txt,1,1
		If MSec>gTxt\time Delete gTxt
	Next

	Flip 0
	WaitTimer( TIMER )
Wend
For gTxt=Each tTxt
	Delete gTxt
Next
Goto Menu

Function loadFigure(pPlr.tPlayer,pFig)
	Local a
	SeekFile gFigFile,pFig*56
	pPlr\A0=ReadInt(gFigFile)
	pPlr\Ani=pPlr\A0
	pPlr\hp=ReadInt(gFigFile)
	pPlr\pDef=ReadInt(gFigFile)
	pPlr\mDef=ReadInt(gFigFile)
	For a=0 To 9
		pPlr\Spl[a]=Spells(ReadInt(gFigFile))
		pPlr\CD[a]=0
	Next
	pPlr\Trg=-1
	pPlr\Act=Null
	pPlr\nAct=Null
End Function

Function Btn(y)
	If mx=>300 And mx<500 And my=>y-30 And my<y+30
		Draw gFx1a,300,y-50,200,100,1
		If mhit Then Return 1
	Else
		Draw gFx1b,300,y-50,200,100,1
	EndIf
End Function

Function Draw(brsh,x#,y#,w,h,z#)
	x=x-.5
	y=y-.5
	Local msh,sur,v1,v2,v3,v4
	Local cu1=0,cv1=0,cu2=1,cv2=1
	If w<0:w=-w:cu1=1:cu2=0:EndIf
	msh=CreateMesh(gParent)
	EntityOrder msh,-z*1000
	EntityFX msh,1
	sur=CreateSurface(msh,brsh)
	v1=AddVertex(sur,x,y,0,cu1,cv1)
	v2=AddVertex(sur,x+w,y,0,cu2,cv1)
	v3=AddVertex(sur,x+w,y+h,0,cu2,cv2)
	v4=AddVertex(sur,x,y+h,0,cu1,cv2)
	AddTriangle(sur,v1,v2,v3)
	AddTriangle(sur,v3,v4,v1)
	Return msh
End Function

Function Cls2()
	Local cnt,a
	cnt=CountChildren(gParent)
	For a=0 To cnt
		FreeEntity GetChild(gParent,1)
	Next
	DrawBlock gImgBG,0,0
End Function

Function AI()
	Local nVal,Val,ValO,trg,a,s,t,Ba,Bs,Bt,Bspl.tSpell
	For a=5 To 9
	If Plr[a]\hp>0
		Plr[a]\sAct=Plr[a]\Act
		Plr[a]\sTrgt=Plr[a]\Trg
		If Plr[a]\nAct=Null:ValO=10:Else:ValO=0:EndIf
		For s=0 To 9
			Plr[a]\Act=Plr[a]\Spl[s]
			If Plr[a]\Act<>Null And Plr[a]\CD[s]<MSec
				t=Plr[a]\Act\AType
				If t=1 Or t=4
					For trg=0 To 4
						Plr[a]\Trg=trg+5*(t=4)
						nVal=ValO+Battle(1)
						If nVal>Val
							Val=nVal
							Ba=a:Bs=s:Bt=trg+5*(t=4):Bspl=Plr[a]\Act
						EndIf
					Next
				Else
					Plr[a]\Trg=-1
					nVal=ValO+Battle(1)
					If nVal>Val
						Val=nVal
						Ba=a:Bs=s:Bt=-1:Bspl=Plr[a]\Act
					EndIf
				EndIf
			EndIf
		Next
		Plr[a]\Act=Plr[a]\sAct
		Plr[a]\Trg=Plr[a]\sTrgt
	EndIf
	Next
	Plr[Ba]\nAct=Bspl
	Plr[Ba]\Trg=Bt
	Plr[Ba]\nSplI=Bs
End Function

Function Battle(sim=0)
	Local Val,Spl.tSpell,a,t,trg,s,e
	For a=0 To 9
		Spl=Plr[a]\Act
		If Spl<>Null
			If Spl\AType=2
				Plr[a]\pDef=Plr[a]\pDef+Spl\pDmg
				Plr[a]\mDef=Plr[a]\mDef+Spl\mDmg
			EndIf
		EndIf
	Next
	For a=0 To 9
		Spl=Plr[a]\Act
		If Spl<>Null And (Plr[a]\exec Or sim>0)
			If sim=0 Plr[a]\exec=0
			t=Spl\AType
			trg=Plr[a]\Trg
			If t=1 Or t=4 And trg=>0
				Val=Val+CalcDmg(a,trg,sim,t=4)
			ElseIf t=8 Or t=16
				s=(a<5)*5
				If t=16 s=5-s
				e=s+4
				For trg=s To e
					Val=Val+CalcDmg(a,trg,sim,t=16)
				Next
			EndIf
		EndIf
	Next
	For a=0 To 9
		Spl=Plr[a]\Act
		If Spl<>Null
			If Spl\AType=2
				Plr[a]\pDef=Plr[a]\pDef-Spl\pDmg
				Plr[a]\mDef=Plr[a]\mDef-Spl\mDmg
			EndIf
		EndIf
	Next
	Return Val
End Function

Function CalcDmg(a,t,sim,h)
	Local Spl.tSpell,d,c,x,y
	Spl=Plr[a]\Act
	If sim=0 c=Rand(1,100)<6
	If Plr[t]\hp<1 Return 0
	d=Spl\pDmg/Float(Plr[t]\pDef)
	d=d+Spl\mDmg/Float(Plr[t]\mDef)
	If h d=Spl\pDmg
	If c d=d*2
	If h=1 And Plr[t]\hp+d>500:d=500-Plr[t]\hp:EndIf
	If sim=0
		Plr[t]\hp=Plr[t]\hp-d*(1-2*h)
		If t<5:x=64+t*48:y=400-t*40:Else:x=976-t*48:y=600-t*40:EndIf
		gTxt=New tTxt:gTxt\txt=d:gTxt\x=x:gTxt\y=y:gTxt\c=$FF0000:gTxt\time=MSec+2500
		If c gTxt\c=$FF8800
		If h gTxt\c=$00FF00
		If c And h gTxt\c=$88FF00
	EndIf
	Return d
End Function

Function ShowCooldowns()
	Local a,b, y,x
	For a=4 To 0 Step -1
		If Plr[a]\hp>0
			gAni=Ani( Plr[a]\Ani )
			Draw gImgFig[gAni\fr[0]],0,y,32,32,1
			x=32
			For b=2 To 9
				If MSec>Plr[a]\CD[b] And Plr[a]\Spl[b]<>Null
					Draw Plr[a]\Spl[b]\Icon,x,y+8,16,16,1
					x=x+16
				EndIf
			Next
			y=y+32
		EndIf
	Next
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D